package com.biganto.visual.roompark.conductor.dialogs.tour_chooser

import android.content.Context
import android.content.Intent
import com.biganto.visual.roompark.R
import com.biganto.visual.roompark.data.repository.file.FileModule
import com.biganto.visual.roompark.domain.model.TourModel
import com.biganto.visual.roompark.player.BigantoPlayerActivity
import com.biganto.visual.roompark.player.unity_utils.LoadTourConfig

/**
 * Created by Vladislav Bogdashkin on 07.04.2020.
 */


const val PLAY_TOUR_DATA_EXTRAS="BIGANTO_PLAYER_TOUR_DATA"

fun startPlayer(context:Context,tour: TourModel)
{
//        hideToursList()
    val playerIntent= Intent(context, BigantoPlayerActivity::class.java)
    val tourConfig = LoadTourConfig(
        tour.tour_id.toInt(),
        tour.targetResolution,
        FileModule.assetsDirectory(context),
        tour.metaPredict,
        tour.previewUrl,
        context.resources?.getBoolean(R.bool.isTablet)?.not()?:true,
        true
    )
    playerIntent.putExtra(PLAY_TOUR_DATA_EXTRAS,tourConfig)
    context.startActivity(playerIntent)
}