package com.biganto.visual.roompark.data.data_provider

import com.biganto.visual.roompark.domain.contract.DeviceUtilsContract
import com.google.android.gms.tasks.OnCompleteListener
import com.google.firebase.iid.FirebaseInstanceId
import io.reactivex.Observable
import io.reactivex.schedulers.Schedulers
import timber.log.Timber
import javax.inject.Inject


/**
 * Created by Vladislav Bogdashkin on 26.03.2020.
 */

class DeviceUtilsRepository @Inject constructor(
) : DeviceUtilsContract {

    override fun getDeviceId(): Observable<String>  =
        Observable.create<String> {emitter ->
            Timber.d("Creat observer")
            FirebaseInstanceId.getInstance().instanceId
                .addOnCompleteListener(OnCompleteListener { task ->
                    if (!task.isSuccessful) {
                        Timber.w(task.exception, "getInstanceId failed")
                        emitter.onError(task.exception!!)
                        return@OnCompleteListener
                    }

                    // Get new Instance ID token
                    task.result?.token?.let { emitter.onNext(it) }

                    emitter.onComplete()
//                Toast.makeText(baseContext, msg, Toast.LENGTH_SHORT).show()
                })
        }.subscribeOn(Schedulers.computation())

}