package com.biganto.visual.roompark.data.repository.api.biganto

import com.biganto.visual.roompark.data.repository.api.biganto.raw.AppVersionRaw
import com.biganto.visual.roompark.data.repository.api.biganto.raw.TourFilesDataRaw
import com.biganto.visual.roompark.data.repository.api.biganto.raw.TourPreviewRaw
import io.reactivex.Flowable
import io.reactivex.Observable
import okhttp3.HttpUrl
import okhttp3.ResponseBody

/**
 * Created by Vladislav Bogdashkin on 13.06.2018.
 */
interface IBigantoApi {



    fun provideHttpUrl():HttpUrl
    fun downloadFile(uri: String, headers: Map<String, String>?): Flowable<ResponseBody>
//    fun getToursFiles(tour_ids: List<Int>, resolution: String): Flowable<Map<String, List<TourFileRaw>>>?

    fun getTourMetaAsString(tour_id: String): Observable<String>?
    fun getTourFiles(tour_id: String, resolution: String): Observable<List<TourFilesDataRaw>>
    fun getAppVersion(): Observable<AppVersionRaw>
    fun getToursPreviewById(tourIds: List<String>): Observable<List<TourPreviewRaw>>

    fun getOfferTours(multiTourId:Int): Observable<List<TourPreviewRaw>>
}