package com.biganto.visual.roompark.data.repository.api.biganto.raw

import java.util.*


/**
 * Created by Vladislav Bogdashkin on 09.06.2018.
 */



data class ErrorRaw(
        val code:Int,
        val message:String
)


data class EstatesRaw(
        val estates:List<EstateRaw>,
        val errors:List<ErrorRaw>?
)


data class EstatesRoomParkRaw(
        val estates:Map<String, EstateRoomParkRaw>,
        val errors:List<ErrorRaw>?
)

data class EstateRoomParkRaw(
        val avaliable:Boolean,
        val long: String, //->long name
        val short: String //->short name
)

data class TourOverviewsRoomParkRaw(
        val tours:List<TourOverviewRoomParkRaw>,
        val errors:List<ErrorRaw>?
)

data class TourOverviewRoomParkRaw(
        val hidden:Boolean,
        val id:String,
        val preview: String,
        val title: String,
        val url:String
)

data class EstateRaw(
        val id:Int,
        val created:Date,
        val title:String,
        val preview:String?,
        val cnt_tours:Int,
        val errors:List<ErrorRaw>?
)


data class ToursPreviewRaw(
        val list:List<TourPreviewRaw>,
        val errors:List<ErrorRaw>?
)

data  class TourPreviewRaw(
        val id:Int,
        val created:Date,
        val updated:Date,
        val type:String,
        val title:String,
        val preview:String,
        val screen:String,
        val hidden:Boolean,
        val resolutions:List<Int>?,
        val features:List<String>?,
        val errors:List<ErrorRaw>?
)


data class TourFileRaw(
        val size:Long,
        val url:String,
        val errors:List<ErrorRaw>?
)


data class TourFilesDataRaw(
        val files:List<TourFileRaw>,
        val id:Int,
        val resolution:Int,
        val total_size:Long,
        val errors:List<ErrorRaw>?
)

data class TourGetFilesRaw(
        val data: Map<String,List<TourFileRaw>>,
        val errors:List<ErrorRaw>?
)

data class OfferTours(
        val data: Map<String,List<TourPreviewRaw>>,
        val errors:List<ErrorRaw>?
)

data class AppVersionRaw(
        val current_version : String,
        val download_url : String?,
        val message : String?,
        val critical : Boolean,
        val errors : List<ErrorRaw>?
)