package com.biganto.visual.roompark.data.repository.api.room_park

import com.biganto.visual.roompark.data.repository.api.room_park.raw.*
import io.reactivex.Observable

/**
 * Created by Vladislav Bogdashkin on 29.10.2019.
 */

interface IRoomParkApi {


    fun authenticate(login: String, pwd: String): Observable<AuthRaw>
    fun subscribeTopic(
        userToken: String,
        deviceToken: String,
        topicName: String,
        topicId:String?
    ): Observable<StatusResponse>

    fun unSuubscribeTopic(
        userToken: String,
        deviceToken: String,
        topicName: String,
        topicId:String?
    ): Observable<StatusResponse>

    fun getDeals(userToken: String): Observable<List<DealRaw>>
    fun getFavorites(userToken: String): Observable<List<EstateRaw>>
    fun getFeeds(): Observable<List<FeedRaw>>
    fun getArticle(id: Int): Observable<ArticleRaw>
    fun getPhotos(parentId: Int): Observable<List<GalleryImageRaw>>
    fun getEstatePlanTypes(estateId: Int): Observable<List<PlanTypeRaw>>
    fun getDirectPlan(
        estateId: Int,
        planType: Int,
        showFurniture: Boolean,
        showSizes: Boolean,
        showWalls: Boolean,
        showElectric: Boolean
    ): Observable<String>

    fun getMultiTour(building: Int, flat: Int): Observable<Int>
    fun getArticlesPage(feedName:String,
                        pageSize:Int = DEFAULT_ARTICLE_PAGE_SIZE,
                        page:Int): Observable<ArticlesListPaginationRaw>

    fun getAlbums(parentId: Int? = null): Observable<List<ImageAlbumRaw>>
    fun getEstate(building: Int, flat: Int): Observable<EstateRaw>
    fun getWebCamsList(): Observable<List<WebCamRaw>>
}

