package com.biganto.visual.roompark.data.repository.api.room_park.raw

import java.util.*

/**
 * Created by Vladislav Bogdashkin on 28.10.2019.
 */

data class AuthRaw(
    val token:String,
    val id: Int,
    val email:String,
    val name:String
)

data class StatusResponse(val status:String)

data class DealRaw(
    val id:String,
    val estate_id:String,
    val opportunity_sum:Int,
    val payment_sum:Int,
    val amount_pay_sum:Int,
    val status_id:Int,
    val manager:String,
    val estate:EstateRaw
)

data class EstateRaw(
    val id:Int,
    val type:String,
    val number:String,
    val common_info: CommonInfoRaw,
    val plan_png:PlanRaw?,
    val plan_jpg:PlanRaw?,
    val url:String,
    val album_id:Int,
    val multitour_id:Int?,
    val multitour_preview:String?
)

data class PlanRaw(
    val url:String,
    val width:Int,
    val height:Int
)

data class CommonInfoRaw(
    val building: Int,
    val section_begin:Int,
    val section_end:Int?,
    val floor:Int,
    val floor_max:Int,
    val area: Float?,
    val area_living: Float?,
    val kind: String?,
    val decoration: String?,
    val ceiling:Float?,
    val windows_face:String?,
    val direction: String?,
    val price_meter:Int?,
    val price:Int?,
    val discount: Float?,
    val doscount_amount: Int?,
    val dependent: Boolean?,
    val rooms:Int?
)

data class EstateRoomRaw(
    val title:String,
    val living:Boolean,
    val area:Float
)

data class FeedRaw(
    val alias:String,
    val title:String
)

data class ArticlesListPaginationRaw(
    val page : Int,
    val pagesize : Int,
    val total : Int,
    val pages : Int,
    val items : List<NewsArticleRaw>
)

data class NewsArticleRaw(
    val id : Int,
    val published : Date,
    val title : String,
    val announce : String,
    val preview : String?
)

data class ArticleRaw(
    val id : Int,
    val published : Date,
    val title : String,
    val announce: String,
    val preview: String?,
    val body : String,
    val feed_alias : String,
    val photo : List<NewsPhotoRaw>?
)

data class NewsPhotoRaw(
    val title : String,
    val url : String
)

data class ImageAlbumRaw(
    val id:Int,
    val title:String,
    val sort:Int,
    val date:Date,
    val parent_id:Int?,
    val preview: String?
)

data class GalleryImageRaw(
    val id:Int,
    val title:String,
    val description:String?,
    val sort:Int,
    val album_id:Int,
    val resolutions:List<ResolutionRaw>
)

data class ResolutionRaw(
    val res_name:String,
    val url:String,
    val width:Int,
    val height:Int
)

data class PlanTypeRaw(
    val plan_id:Int,
    val title:String,
    val features: List<String>,
    val explication: List<EstateRoomRaw>?
)

data class MultiTourRaw(
    val multiTourId:Int
)


data class ErrorRaw(
    val code:Int,
    val message:String
)


data class AppVersionRaw(
    val current_version : String,
    val download_url : String?,
    val message : String?,
    val critical : Boolean,
    val errors : List<ErrorRaw>?
)

data class WebCamRaw(
    val id:Int,
    val title:String,
    val streams:List<StreamRaw>
)

data class StreamRaw(
    val res_name:String,
    val hls:String,
    val rtmp:String
)