package com.biganto.visual.roompark.data.repository.db.requrey.model

import com.biganto.visual.roompark.data.repository.api.biganto.raw.TourFileRaw
import com.biganto.visual.roompark.data.repository.db.requrey.RevisionString
import com.biganto.visual.roompark.data.repository.db.requrey.utils.RevisionStringConverter
import io.requery.*

/**
 * Created by Vladislav Bogdashkin on 15.06.2018.
 */

@Entity
interface File :Persistable {
//       @get:Key
//       var id: String
//       @get:Convert(URIConverter::class)
       @get:Key
       @get:Convert(RevisionStringConverter::class)
       val uri: RevisionString
       val totalSize: Long
       val downloadedSize: Long
       @get:Nullable
       val isDownloaded: Boolean

//       @get:ForeignKey(references = Skybox::class)
//       @get:ManyToOne(cascade = arrayOf(CascadeAction.NONE))
//       var skyboxId:Skybox?
}


fun fromRaw(raw: TourFileRaw):FileEntity {

       val entity = FileEntity()
       entity.setDownloaded(false)
       entity.setDownloadedSize(0L)
       entity.setTotalSize(raw.size)
       entity.setUri(RevisionString(raw.url.substring(raw.url.indexOf("asset"))))
       return entity
}

fun fromRaw(raw: List<TourFileRaw>): List<FileEntity> =List(raw.size) { index-> fromRaw(raw[index]) }