package com.biganto.visual.roompark.data.repository.db.requrey.utils;


import com.biganto.visual.roompark.data.repository.db.requrey.RevisionString;

import java.util.ArrayList;

import io.requery.Converter;

public class RevisionStringListConverter implements Converter<ArrayList<RevisionString>, String> {

    private static final String stringDelimeter=">RS<";

    @SuppressWarnings("unchecked")
    @Override
    public Class<ArrayList<RevisionString>> getMappedType() {
        return (Class)ArrayList.class;
    }

    @Override
    public Class<String> getPersistedType() {
        return String.class;
    }

    @Override
    public Integer getPersistedSize() {
        return null;
    }

    @Override
    public String convertToPersisted(ArrayList<RevisionString> value) {
        if (value == null) {
            return "";
        }
        StringBuilder sb = new StringBuilder();
        int index = 0;
        for (RevisionString str: value) {
            if (index > 0) {
                sb.append(stringDelimeter);
            }
            sb.append(str.revisionUri());
            index++;
        }
        return sb.toString();
    }

    @Override
    public ArrayList<RevisionString> convertToMapped(Class<? extends ArrayList<RevisionString>> type,
                                             String value) {
        ArrayList<RevisionString> list = new ArrayList<>();
        if (value != null && !value.isEmpty())
            for (String s : value.split(stringDelimeter))
                list.add(new RevisionString(s));
        return list;
    }
}
