package com.biganto.visual.roompark.di.dagger

import android.app.Application
import com.biganto.visual.androidplayer.data.repository.local.ILocalStore
import com.biganto.visual.roompark.base.RoomParkApplication
import com.biganto.visual.roompark.data.local.LocalStorage
import com.biganto.visual.roompark.data.repository.api.biganto.IBigantoApi
import com.biganto.visual.roompark.data.repository.api.retrofit.di.RetrofitModule
import com.biganto.visual.roompark.data.repository.api.room_park.IRoomParkApi
import com.biganto.visual.roompark.data.repository.db.IDb
import com.biganto.visual.roompark.data.repository.db.requrey.DbModule
import com.biganto.visual.roompark.data.repository.file.FileModule
import com.biganto.visual.roompark.domain.contract.*
import dagger.BindsInstance
import dagger.Component
import dagger.android.AndroidInjectionModule
import dagger.android.AndroidInjector
import dagger.android.support.AndroidSupportInjectionModule
import javax.inject.Singleton

/**
 * Created by Vladislav Bogdashkin on 13.06.2018.
 */

@Singleton
@Component(modules =
[   AppModule::class,
    DataModule::class,
    RetrofitModule::class,
    DbModule::class,
    LocalStorage::class,
//    LocalStorage::class,
//    AppVersionModule::class,
    AndroidInjectionModule::class,
    AndroidSupportInjectionModule::class,
//    MappingProvider::class,
    ActivityModule::class,
    ContractRepositoryModule::class,
    AppActivityModule ::class,
    FileModule::class])
interface AppComponent : AndroidInjector<RoomParkApplication>{

    fun authC(): AuthContract

    fun feedsC(): FeedsContract

    fun feedsAlb(): DevProgressContract

    fun estateRep(): DealContract

    fun filesRep(): FilesContract

    fun subsRep(): SubscriptionContract

    fun provideLocal():ILocalStore

    fun provideApi(): IRoomParkApi

    fun provideBigantoApi(): IBigantoApi

    fun providedb():IDb

    fun provideUtils():DeviceUtilsContract

    fun provideTour():TourContract

    fun provideAppContext():Application

    fun provideFileSystem(): FileModule


    @Component.Factory
    interface Factory{

        fun create(
            @BindsInstance app:RoomParkApplication
        ):AppComponent

    }
}