package com.biganto.visual.roompark.di.dagger

import com.biganto.visual.roompark.data.data_provider.*
import com.biganto.visual.roompark.data.local.LocalStorage
import com.biganto.visual.roompark.data.repository.api.biganto.BigantoRetrofitRepository
import com.biganto.visual.roompark.data.repository.api.biganto.IBigantoApi
import com.biganto.visual.roompark.data.repository.api.retrofit.di.RetrofitModule
import com.biganto.visual.roompark.data.repository.api.room_park.IRoomParkApi
import com.biganto.visual.roompark.data.repository.api.room_park.RetrofitRepository
import com.biganto.visual.roompark.data.repository.db.IDb
import com.biganto.visual.roompark.data.repository.db.requrey.DbModule
import com.biganto.visual.roompark.data.repository.db.requrey.RequeryRepository
import com.biganto.visual.roompark.domain.contract.*
import dagger.Binds
import dagger.Component
import dagger.Module
import javax.inject.Singleton

@Component
interface DataComponent{

}

@Module(includes = [DataModule::class, RetrofitModule::class, DbModule::class,LocalStorage::class])
abstract class ContractRepositoryModule {

    @Singleton
    @Binds
    abstract fun provideAuth(contract:AuthContractModule):AuthContract

    @Singleton
    @Binds
    abstract fun provideFeedsContract(impl: FeedsContractModule): FeedsContract

    @Binds
    @Singleton
    abstract fun provideDevProgressContract(impl: AlbumsContractModule): DevProgressContract

    @Binds
    @Singleton
    abstract fun provideEstateContract(impl: EstateRepository): DealContract

    @Binds
    @Singleton
    abstract fun provideSubscriptionsContract(impl: SubscriptionRepository): SubscriptionContract

    @Binds
    @Singleton
    abstract fun provideFilesContract(impl: FilesContractModule): FilesContract

    @Binds
    @Singleton
    abstract fun provideDeviceContract(impl: DeviceUtilsRepository): DeviceUtilsContract

    @Binds
    @Singleton
    abstract fun provideTourContract(impl: ToursRepository): TourContract
}



@Module
abstract class DataModule {

    @Singleton
    @Binds
    abstract fun provideBigantoApi(bigantoApi:BigantoRetrofitRepository): IBigantoApi


    @Singleton
    @Binds
    abstract fun provideRoomParkApi(roomParkApi:RetrofitRepository): IRoomParkApi

    @Singleton
    @Binds
    abstract fun provideDb(db: RequeryRepository) : IDb

}