package com.biganto.visual.roompark.domain.custom_exception

import androidx.annotation.StringRes
import com.biganto.visual.roompark.R
import com.biganto.visual.roompark.data.repository.api.room_park.raw.ErrorRaw


/**
 * Created by Vladislav Bogdashkin on 09.04.2019.
 */

const val CUSTOM_API_ERROR_RESPONSE_CODE_100=100
const val CUSTOM_API_ERROR_RESPONSE_CODE_101=101
const val CUSTOM_API_ERROR_RESPONSE_CODE_102=102
const val CUSTOM_API_ERROR_RESPONSE_CODE_103=103
const val CUSTOM_API_ERROR_RESPONSE_CODE_104=104
const val CUSTOM_API_ERROR_RESPONSE_CODE_111=111
const val CUSTOM_API_ERROR_RESPONSE_CODE_112=112

const val CUSTOM_API_ERROR_RESPONSE_CODE_201=201
const val CUSTOM_API_ERROR_RESPONSE_CODE_202=202
const val CUSTOM_API_ERROR_RESPONSE_CODE_203=203
const val CUSTOM_API_ERROR_RESPONSE_CODE_204=204
const val CUSTOM_API_ERROR_RESPONSE_CODE_205=205
const val CUSTOM_API_ERROR_RESPONSE_CODE_206=206

const val CUSTOM_API_ERROR_RESPONSE_CODE_211=211
const val CUSTOM_API_ERROR_RESPONSE_CODE_212=212
const val CUSTOM_API_ERROR_RESPONSE_CODE_213=213

const val CUSTOM_API_ERROR_RESPONSE_CODE_221=221

const val CUSTOM_API_ERROR_RESPONSE_CODE_231=231

const val CUSTOM_API_ERROR_RESPONSE_CODE_TOUR_NOT_FOUND=2001

@StringRes
const val CUSTOM_API_ERROR_RESPONSE_CODE_100_MESSAGE_ID= R.string.api_error_100
@StringRes
const val CUSTOM_API_ERROR_RESPONSE_CODE_101_MESSAGE_ID=R.string.api_error_101
@StringRes
const val CUSTOM_API_ERROR_RESPONSE_CODE_102_MESSAGE_ID=R.string.api_error_102
@StringRes
const val CUSTOM_API_ERROR_RESPONSE_CODE_103_MESSAGE_ID=R.string.api_error_103
@StringRes
const val CUSTOM_API_ERROR_RESPONSE_CODE_104_MESSAGE_ID=R.string.api_error_104
@StringRes
const val CUSTOM_API_ERROR_RESPONSE_CODE_111_MESSAGE_ID=R.string.api_error_111
@StringRes
const val CUSTOM_API_ERROR_RESPONSE_CODE_112_MESSAGE_ID=R.string.api_error_112


@StringRes
const val CUSTOM_API_ERROR_RESPONSE_CODE_201_MESSAGE_ID= R.string.api_error_201
@StringRes
const val CUSTOM_API_ERROR_RESPONSE_CODE_202_MESSAGE_ID=R.string.api_error_202
@StringRes
const val CUSTOM_API_ERROR_RESPONSE_CODE_203_MESSAGE_ID=R.string.api_error_203
@StringRes
const val CUSTOM_API_ERROR_RESPONSE_CODE_204_MESSAGE_ID=R.string.api_error_204
@StringRes
const val CUSTOM_API_ERROR_RESPONSE_CODE_205_MESSAGE_ID=R.string.api_error_205
@StringRes
const val CUSTOM_API_ERROR_RESPONSE_CODE_206_MESSAGE_ID=R.string.api_error_206

@StringRes
const val CUSTOM_API_ERROR_RESPONSE_CODE_211_MESSAGE_ID=R.string.api_error_211
@StringRes
const val CUSTOM_API_ERROR_RESPONSE_CODE_212_MESSAGE_ID=R.string.api_error_212
@StringRes
const val CUSTOM_API_ERROR_RESPONSE_CODE_213_MESSAGE_ID=R.string.api_error_213

@StringRes
const val CUSTOM_API_ERROR_RESPONSE_CODE_221_MESSAGE_ID=R.string.api_error_221

@StringRes
const val CUSTOM_API_ERROR_RESPONSE_CODE_231_MESSAGE_ID=R.string.api_error_231


@StringRes
const val CUSTOM_API_ERROR_RESPONSE_CODE_TOUR_NOT_FOUND_MESSAGE_ID=R.string.api_error_2001
@StringRes
const val CUSTOM_API_ERROR_DEFAULT_MESSAGE_ID=R.string.api_error_default

sealed class CustomApiException(val code:Int,@StringRes  val messageStringId: Int?, val customMessage:String? = null):Exception() {
    class NotAuthorizedException() : CustomApiException(CUSTOM_API_ERROR_RESPONSE_CODE_100
            ,messageStringId= CUSTOM_API_ERROR_RESPONSE_CODE_100_MESSAGE_ID)
    class TokenSyntaxException() : CustomApiException(CUSTOM_API_ERROR_RESPONSE_CODE_101
            ,messageStringId= CUSTOM_API_ERROR_RESPONSE_CODE_101_MESSAGE_ID)
    class UserWithTokenNotFoundException() : CustomApiException(CUSTOM_API_ERROR_RESPONSE_CODE_102
            ,messageStringId= CUSTOM_API_ERROR_RESPONSE_CODE_102_MESSAGE_ID)
    class TokenEstimatedException() : CustomApiException(CUSTOM_API_ERROR_RESPONSE_CODE_103
            ,messageStringId= CUSTOM_API_ERROR_RESPONSE_CODE_103_MESSAGE_ID)
    class UserBannedException() : CustomApiException(CUSTOM_API_ERROR_RESPONSE_CODE_104
            ,messageStringId= CUSTOM_API_ERROR_RESPONSE_CODE_104_MESSAGE_ID)
    class WrongLoginException() : CustomApiException(CUSTOM_API_ERROR_RESPONSE_CODE_111
            ,messageStringId= CUSTOM_API_ERROR_RESPONSE_CODE_111_MESSAGE_ID)
    class WrongPasswordException() : CustomApiException(CUSTOM_API_ERROR_RESPONSE_CODE_112
            ,messageStringId= CUSTOM_API_ERROR_RESPONSE_CODE_112_MESSAGE_ID)

    class UnexpectedSubscriptionTopicId() : CustomApiException(CUSTOM_API_ERROR_RESPONSE_CODE_201
        ,messageStringId= CUSTOM_API_ERROR_RESPONSE_CODE_201_MESSAGE_ID)
    class SubcriptionAldreadyExists() : CustomApiException(CUSTOM_API_ERROR_RESPONSE_CODE_202
        ,messageStringId= CUSTOM_API_ERROR_RESPONSE_CODE_202_MESSAGE_ID)
    class DealCrmTimeoutException() : CustomApiException(CUSTOM_API_ERROR_RESPONSE_CODE_203
        ,messageStringId= CUSTOM_API_ERROR_RESPONSE_CODE_203_MESSAGE_ID)
    class DealCrmWrongAnswearFormatException() : CustomApiException(CUSTOM_API_ERROR_RESPONSE_CODE_204
        ,messageStringId= CUSTOM_API_ERROR_RESPONSE_CODE_204_MESSAGE_ID)
    class DealCrmError() : CustomApiException(CUSTOM_API_ERROR_RESPONSE_CODE_205
        ,messageStringId= CUSTOM_API_ERROR_RESPONSE_CODE_205_MESSAGE_ID)
    class SubscriptionDbException() : CustomApiException(CUSTOM_API_ERROR_RESPONSE_CODE_206
        ,messageStringId= CUSTOM_API_ERROR_RESPONSE_CODE_206_MESSAGE_ID)

    class WrongFeedException() : CustomApiException(CUSTOM_API_ERROR_RESPONSE_CODE_211
        ,messageStringId= CUSTOM_API_ERROR_RESPONSE_CODE_211_MESSAGE_ID)
    class ArticleNotFoundException() : CustomApiException(CUSTOM_API_ERROR_RESPONSE_CODE_212
        ,messageStringId= CUSTOM_API_ERROR_RESPONSE_CODE_212_MESSAGE_ID)
    class ArticleIdExpectedException() : CustomApiException(CUSTOM_API_ERROR_RESPONSE_CODE_213
        ,messageStringId= CUSTOM_API_ERROR_RESPONSE_CODE_213_MESSAGE_ID)

    class PhotoIdExpectedException() : CustomApiException(CUSTOM_API_ERROR_RESPONSE_CODE_221
        ,messageStringId= CUSTOM_API_ERROR_RESPONSE_CODE_221_MESSAGE_ID)

    class WrongZoneIdException() : CustomApiException(CUSTOM_API_ERROR_RESPONSE_CODE_231
        ,messageStringId= CUSTOM_API_ERROR_RESPONSE_CODE_231_MESSAGE_ID)


    class TourByIdNotFoundException() : CustomApiException(
            CUSTOM_API_ERROR_RESPONSE_CODE_TOUR_NOT_FOUND
            ,messageStringId= CUSTOM_API_ERROR_RESPONSE_CODE_TOUR_NOT_FOUND_MESSAGE_ID)
    class UnknownCustomApiException(code: Int, @StringRes messageStringId: Int?, apiMessage:String?)
        : CustomApiException(code,messageStringId,apiMessage)

}

//as an agreement error message should be correct for user (and localized, if needed) on server-side
fun parseException(err: ErrorRaw) =
    CustomApiException.UnknownCustomApiException(err.code, null, err.message)



