package com.biganto.visual.roompark.domain.interactor

import com.biganto.visual.roompark.domain.model.ArticleModel
import com.biganto.visual.roompark.domain.use_case.FeedUseCase
import com.biganto.visual.roompark.domain.use_case.SubscriptionUseCase
import io.reactivex.Observable
import java.util.*
import javax.inject.Inject

/**
 * Created by Vladislav Bogdashkin on 09.10.2019.
 */

class ArticleInteractor @Inject constructor(
    private val uc:FeedUseCase
) {

    fun fetchArticle(articleId: Int): Observable<ArticleModel> =
        uc.getArticle(articleId)

    fun setArticleRead(articleId: Int) = uc.setRead(articleId)

//        Single.just(
//        when (articleId) {
//            2 -> article2
//            else -> error("unknown feedId")
//        }
//    )

    companion object{

        val article2 = ArticleModel(
            2,
            Date(12315536L),
            "В ЖК «РУМЯНЦЕВО-ПАРК» ИПОТЕЧНАЯ СТАВКА - 6,5%",
            "С марта 2019 года для всех покупателей квартир в жилом комплексе бизнес-класса «Румянцево-Парк» от компании Lexion Development, доступна минимальная ипотечная ставка от банка-партнера ПАО Банк ВТБ в размере 6,5% по программе субсидирования ипотеки от застройщика. \n" +
                    "\n" +
                    "Минимальная процентная ставка действительна при покупке любого типа квартир в жилом комплексе – от студий 23,8 кв. м до четырехкомнатных квартир площадью 102,7 кв. м. Минимальный первоначальный взнос составляет от 20%.\n" +
                    "\n" +
                    "Более подробная информация доступна в офисе продаж по телефону: +7 (495) 127-86-86",
            "https://room-park.ru/assets/news_articles/preview/00/00/00/96-a972cd.jpeg",
            null,
            false
        )
    }
}






























