package com.biganto.visual.roompark.domain.model

import com.biganto.visual.roompark.data.repository.api.room_park.raw.StreamRaw
import com.biganto.visual.roompark.data.repository.api.room_park.raw.WebCamRaw

/**
 * Created by Vladislav Bogdashkin on 23.09.2019.
 */

data class WebCamModel(
    val title:String,
    val index:Int,
    val streams:List<StreamModel>
)

data class StreamModel(
    val res_name:String,
    val hls:String,
    val rtmp:String
)

data class WebCamListModel(val items:List<WebCamModel>)

fun fromRaw(raw:StreamRaw) = StreamModel(
    raw.res_name,
    raw.hls,
    raw.rtmp
)

fun fromRaw(raw:WebCamRaw) = WebCamModel(
    raw.title,
    raw.id,
    List(raw.streams.size){i -> fromRaw(raw.streams[i]) }
)



fun fromRawList(raw:List<WebCamRaw>) =
    WebCamListModel(List(raw.size){ i -> fromRaw(raw[i]) })




