package com.biganto.visual.roompark.player.unity_utils

import android.os.Parcel
import android.os.Parcelable

/**
 * Created by Vladislav Bogdashkin on 08.05.2019.
 */

data class LoadTourConfig(
        val tourId:Int,
        val targetResolution:Int,
        val cacheFolderUri:String,
        val metaUri:String,
        val previewUri:String?,
        val AllowVR:Boolean,
        val AllowDollhouse:Boolean) : Parcelable {
    constructor(parcel: Parcel) : this(
            parcel.readInt(),
            parcel.readInt(),
            parcel.readString(),
            parcel.readString(),
            parcel.readString(),
            parcel.readInt()!= 0,
            parcel.readInt() == 1
            )

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeInt(tourId)
        parcel.writeInt(targetResolution)
        parcel.writeString(cacheFolderUri)
        parcel.writeString(metaUri)
        parcel.writeString(previewUri)
        parcel.writeInt(if (AllowVR)1 else 0 )
        parcel.writeInt(if (AllowDollhouse)1 else 0)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<LoadTourConfig> {
        override fun createFromParcel(parcel: Parcel): LoadTourConfig {
            return LoadTourConfig(parcel)
        }

        override fun newArray(size: Int): Array<LoadTourConfig?> {
            return arrayOfNulls(size)
        }
    }
}