package com.biganto.visual.roompark.player.unity_utils;

import android.os.Handler;

import timber.log.Timber;

/**
 * Created by Vladislav Bogdashkin on 23.08.2018.
 */
public final class UnityBridge {
    // Содержит ссылку на C# реализацию интерфейса
    // Перенаправляет вызов в Unity поток
    private static Handler unityMainThreadHandler;


    // Функция перевода выполнения в Unity поток, потребуется в дальнейшем
    public static void runOnUnityThread(Runnable runnable) {
        if (unityMainThreadHandler != null && runnable != null) {
            unityMainThreadHandler.post(runnable);
        }
    }

    public static void unRegisterHandler() {
        if(unityMainThreadHandler != null)
            unityMainThreadHandler.getLooper().quit();
        unityMainThreadHandler=null;

    }

    public static void registerHandler() {
        Timber.d(" handler: %s",unityMainThreadHandler );
        if(unityMainThreadHandler == null) {
            // Так как эту функцию вызываем всегда на старте Unity,
            // этот вызов идет из нужного нам в дальнейшем потока,
            // создадим для него Handler
            unityMainThreadHandler = new Handler();
        }
        Timber.d(" handler: %s",unityMainThreadHandler );
    }

}