package com.biganto.visual.roompark.player.unity_utils.requests_raw;


import com.biganto.visual.roompark.player.unity_utils.LoadTourConfig;

/**
 * Created by Vladislav Bogdashkin on 20.08.2018.
 */
public class UPBuildTourRequest extends UPBaseRequest{

    public int TourId;
    public int TargetResolution;
    public String AssetsDirectory;
    public String MetaPredict;
    public String tour_preview;
    public Boolean AllowVR=true;
    public Boolean AllowDollhouse=true;

    public UPBuildTourRequest(){}
    public UPBuildTourRequest(
            int tour_id,
            int target_tex_resolution,
            String sd_core_folder_uri,
            String meta_file_path,
            String tour_preview,
            boolean allow_vr,
            boolean allow_dollhouse
    ) {
        this.TourId = tour_id;
        this.TargetResolution = target_tex_resolution;
        this.AssetsDirectory = sd_core_folder_uri;
        this.MetaPredict = meta_file_path;
        this.tour_preview = tour_preview;
        this.AllowVR = allow_vr;
        this.AllowDollhouse = allow_dollhouse;
    }

    public UPBuildTourRequest(LoadTourConfig tour) {
        this(tour.getTourId(), tour.getTargetResolution(), tour.getCacheFolderUri(),
                tour.getMetaUri(), tour.getPreviewUri(),tour.getAllowVR(),tour.getAllowDollhouse());
    }
}


