package com.biganto.visual.roompark.presentation.screen.albums

import com.biganto.visual.roompark.conductor.BigantoBaseViewState
import com.biganto.visual.roompark.domain.model.AlbumPreviewModel
import com.biganto.visual.roompark.domain.model.AlbumSortedModel
import com.biganto.visual.roompark.util.monades.ExceptionString

/**
 * Created by Vladislav Bogdashkin on 30.09.2019.
 */


sealed class AlbumsScreenViewState : BigantoBaseViewState() {
    class Idle : AlbumsScreenViewState()
    class AlbumsListLoaded(val list:List<AlbumPreviewModel>, val selectedAlbumId:Int) : AlbumsScreenViewState()
    class AlbumsSelected(val list:List<AlbumSortedModel>) : AlbumsScreenViewState()
    class HeaderAlbumChoosed(val item:AlbumPreviewModel) : AlbumsScreenViewState()
    class PhotoSelected(val photoId:Int) : AlbumsScreenViewState()
    class SomeError(val exception: ExceptionString) : AlbumsScreenViewState()
    class RestoreView(val restore:RestoreModel) : AlbumsScreenViewState()
    class SubscriptionStatus(val subState: Boolean) : AlbumsScreenViewState()
    class SubscriptionError(val subState: Boolean) : AlbumsScreenViewState()
}