package com.biganto.visual.roompark.presentation.screen.deal

import com.biganto.visual.roompark.conductor.BigantoBaseViewState
import com.biganto.visual.roompark.domain.model.DealModel
import com.biganto.visual.roompark.domain.model.StatusModel
import com.biganto.visual.roompark.domain.model.TourModel
import com.biganto.visual.roompark.util.monades.ExceptionString

/**
 * Created by Vladislav Bogdashkin on 30.09.2019.
 */


sealed class DealScreenViewState : BigantoBaseViewState() {
    class Idle : DealScreenViewState()
    class LoadDeal(val estate:DealModel,val statusList:List<StatusModel>) : DealScreenViewState()
    class SomeError(val exception: ExceptionString) : DealScreenViewState()
    class RestoreView(val restore:RestoreModel) : DealScreenViewState()
    class SubscriptionStatus(val subState: Boolean) : DealScreenViewState()
    class SubscriptionError(val subState: Boolean) : DealScreenViewState()
    class ToursLoaded(val tours:List<TourModel>) : DealScreenViewState()
}