package com.biganto.visual.roompark.presentation.screen.favorites

import com.biganto.visual.roompark.conductor.BigantoBaseViewState
import com.biganto.visual.roompark.domain.model.EstateModel
import com.biganto.visual.roompark.domain.model.TourModel
import com.biganto.visual.roompark.util.monades.ExceptionString

/**
 * Created by Vladislav Bogdashkin on 30.09.2019.
 */


sealed class FavoritesScreenViewState : BigantoBaseViewState() {
    class Idle : FavoritesScreenViewState()
    class FavoriteEstatesLoaded(val items: List<EstateModel>) : FavoritesScreenViewState()
    class SomeError(val exception: ExceptionString) : FavoritesScreenViewState()
    class ToursLoaded(val tours:List<TourModel>) : FavoritesScreenViewState()
}