package com.biganto.visual.roompark.presentation.screen.feed_list

import com.biganto.visual.roompark.conductor.BigantoBaseViewState
import com.biganto.visual.roompark.domain.model.ArticlePreviewModel
import com.biganto.visual.roompark.util.monades.ExceptionString

/**
 * Created by Vladislav Bogdashkin on 30.09.2019.
 */


sealed class ArticlesScreenViewState : BigantoBaseViewState() {
    class Idle : ArticlesScreenViewState()
    class ArticlesLoaded(val items: List<ArticlePreviewModel>) : ArticlesScreenViewState()
    class SomeError(val exception: ExceptionString) : ArticlesScreenViewState()
    class ArticlesScrollPage(val items:List<ArticlePreviewModel>) : ArticlesScreenViewState()
    class RestoreView(val restore:RestoreModel) : ArticlesScreenViewState()
    class SubscriptionStatus(val subState: Boolean) : ArticlesScreenViewState()
    class SubscriptionError(val subState: Boolean) : ArticlesScreenViewState()
}
