package com.biganto.visual.roompark.presentation.screen.settings

import com.biganto.visual.roompark.conductor.BigantoBaseViewState
import com.biganto.visual.roompark.domain.model.CachedDataModel
import com.biganto.visual.roompark.domain.model.SettingsModel
import com.biganto.visual.roompark.domain.model.TitledSubscriptionModel
import com.biganto.visual.roompark.util.monades.ExceptionString

/**
 * Created by Vladislav Bogdashkin on 30.09.2019.
 */


sealed class SettingsScreenViewState : BigantoBaseViewState() {
    class Idle : SettingsScreenViewState()
    class LoadSettingsList(val settings:SettingsModel) : SettingsScreenViewState()
//    class LoadCachedInfo(val cached:SettingsModel) : SettingsScreenViewState()
    class SomeError(val exception: ExceptionString) : SettingsScreenViewState()
    class SignOut() : SettingsScreenViewState()
    class OnCacheDeleting(val progress:Float) : SettingsScreenViewState()
    class LoadSubscriptions(val list:List<TitledSubscriptionModel>) : SettingsScreenViewState()
    class LoadCachInfo(val list: List<CachedDataModel>) : SettingsScreenViewState()
    class SubscriptionStatus(val subId:Int,val subState: Boolean) : SettingsScreenViewState()
    class SubscriptionError(val subId:Int,val subState: Boolean) : SettingsScreenViewState()
    class RestoreView(val restore:RestoreModel) : SettingsScreenViewState()
}
